﻿Type=Class
Version=1.8
B4J=true
@EndOfDesignText@
'Class module - Change Category
Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	Private Reps As Int
	Private itemLbl As Label
	Private CatTV As TableView
	Private CIDs As Int	
	Private SelRow As Int
	Private IIdx As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form, idxs As Int)
	frm.Initialize("frm", 465, 400)
	frm.Title = "Change Category for Item"
	frm.SetFormStyle("UTILITY")
	frm.Resizable = False
	frm.RootPane.LoadLayout("change")
	frm.SetOwner(Parent)	
	
	IIdx = idxs 	' Item ID
	SelRow = 0	
	Reps = 0

	SetupTableView
	FillList
	ShowItem
End Sub

Public Sub Show As Int
	frm.WindowLeft = Main.loc.left + (Main.loc.width - frm.Width) / 2
	frm.WindowTop = Main.loc.top + (Main.loc.height - frm.Height) / 2
		
	frm.ShowAndWait
	If Reps = 1 Then
		Return 1
	Else
		Return 0
	End If
End Sub

' Load the Categories into the CatTV Table View
Private Sub FillList	
	Dim CatLst As List
	
	CatLst.Initialize

	' empty the CatTV Table View of all its items
	CatTV.Items.Clear
	
	' Load the Categories Table into the CatTV Table View
	DBUtils.LoadTableView(Main.SQL1, "SELECT CId, [Categories] FROM Categories ORDER BY [Categories]", Null, 0, CatTV)
	
	If CatTV.Items.Size > 0 Then
		CatTV.SelectedRow = SelRow
		
		CatLst = CatTV.SelectedRowValues
		CIDs = CatLst.Get(0)
	Else
		CIDs = -1
	End If
End Sub

Private Sub ShowItem
	Dim Qry1 As String
	Dim m As Map
	
	m.Initialize
	
	Qry1 = "SELECT * FROM Items WHERE IId = " & IIdx
	m = DBUtils.ExecuteMap(Main.SQL1, Qry1, Null)
	itemLbl.Text = m.Get("items")
End Sub

' Setup the Categories Table View (CatTV)
Private Sub SetupTableView
	Dim CList As List
	
	CList.Initialize
	CList.Add("CId")
	CList.Add("Category")
	CatTV.SetColumns(CList)

	CatTV.SetColumnVisible(0,False)	' CId
	CatTV.SetColumnWidth(1, 244.0)	' Category

	CList.Clear
End Sub

Sub cancelBtn_Action
	Reps = 0
	frm.Close
End Sub

' change the CatID for this item
Sub changeBtn_Action
	' update record
	Dim WhereFields As Map
	WhereFields.Initialize
	WhereFields.Put("IId", IIdx)
	DBUtils.UpdateRecord(Main.SQL1, "Items", "CId", CIDs, WhereFields)

	Reps = 1
	frm.Close
End Sub

Sub CatTV_SelectedRowChanged(Index As Int, Row() As Object)
	' get SelRaceID
	If Index = -1 Then Return
	SelRow = Index
	CIDs = Row(0) 'CId is the first column
End Sub